VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Pipe Sample"
   ClientHeight    =   4215
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6765
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4215
   ScaleWidth      =   6765
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Start Server"
      Height          =   975
      Left            =   120
      TabIndex        =   1
      Top             =   0
      Width           =   6495
      Begin VB.CommandButton btnClearLog 
         Caption         =   "Clear Log"
         Height          =   375
         Left            =   4920
         TabIndex        =   5
         Top             =   360
         Width           =   1335
      End
      Begin VB.CommandButton btnStopServer 
         Caption         =   "Stop Server"
         Height          =   375
         Left            =   3360
         TabIndex        =   4
         Top             =   360
         Width           =   1335
      End
      Begin VB.CommandButton btnConnectClient 
         Caption         =   "Connect Client"
         Height          =   375
         Left            =   1800
         TabIndex        =   3
         Top             =   360
         Width           =   1335
      End
      Begin VB.CommandButton btnStartServer 
         Caption         =   "Start Server"
         Height          =   375
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   1335
      End
   End
   Begin VB.TextBox txtLog 
      Height          =   3015
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   1080
      Width           =   6495
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim PipeHandle As Long
Private Const szPipeName = "\\.\pipe\PipeTest"
    
Private Sub btnClearLog_Click()
    txtLog.Text = ""
End Sub

Private Sub btnConnectClient_Click()
    Dim bret As Boolean
    bret = False
       
    bret = WaitNamedPipe(szPipeName, PROVIDER_WAIT_TIME)
    If bret = False Then
        ShowLastStatus
    Else
        ShowLastStatus "PIPE is available for connection"
        Dim flg As Boolean
        Dim dwWrite As Long
        Dim szPipeUpdate As String
        Dim hPipeHandle As Long
        Dim sa As SECURITY_ATTRIBUTES
        Dim ovl As OVERLAPPED
                
        hPipeHandle = CreateFile(szPipeName, GENERIC_WRITE, 0, sa, OPEN_EXISTING, 0, 0)
        
        szPipeUpdate = "HI FROM CLIENT"
        
        flg = WriteFile(hPipeHandle, szPipeUpdate, Len(szPipeUpdate), dwWrite, ovl)

        If False = flg Then
            ShowLastStatus "Sending string : " + szPipeUpdate + " Failed"
        Else
            ShowLastStatus "Sending string : " + szPipeUpdate
        End If
    End If
End Sub

Private Sub btnStartServer_Click()
    Dim hPipeHandle As Long
    Dim sa As SECURITY_ATTRIBUTES
    
    hPipeHandle = CreateNamedPipe(szPipeName, _
        PIPE_ACCESS_DUPLEX Or FILE_FLAG_OVERLAPPED, _
        PIPE_TYPE_MESSAGE Or PIPE_WAIT, 1, _
        MAX_PATH, MAX_PATH, _
        PROVIDER_WAIT_TIME, sa)

    If INVALID_HANDLE_VALUE = hPipeHandle Then
        ShowLastStatus
    Else
        PipeHandle = hPipeHandle
        ShowLastStatus "Server successfully started and waiting for the client to send data"
        CreateServerLoop
    End If
End Sub

Private Function ShowLastStatus(Optional szMsg As String)
    If szMsg = "" Then
        Dim MsgBuf As String
        MsgBuf = Space$(1024)
        If FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, _
                           Err.LastDllError, 0&, MsgBuf, Len(MsgBuf), ByVal 0&) Then
            txtLog.Text = txtLog.Text + MsgBuf + vbNewLine
        End If
    Else
        txtLog.Text = txtLog.Text + szMsg + vbNewLine
    End If
    txtLog.SelStart = Len(txtLog.Text)
End Function

Private Function CreateServerLoop()
    Dim ovl As OVERLAPPED
    Dim fConnected, fSuccess As Boolean
    Dim iConnectionStatus As Long
    Dim chRequest As String
    Dim cbBytesRead As Long
    
    Do
        DoEvents
        
        If PipeHandle = 0 Then
            Exit Do
        End If
        
        iConnectionStatus = ConnectNamedPipe(PipeHandle, ovl)
        
        If iConnectionStatus <> 0 Then
            fConnected = True
        Else
            If Err.LastDllError = ERROR_PIPE_CONNECTED Then
                fConnected = True
            Else
                fConnected = False
            End If
        End If
        
        If fConnected = True Then
            chRequest = Space(MAX_PATH)
            fSuccess = ReadFile(PipeHandle, chRequest, MAX_PATH, cbBytesRead, ovl)
         
            If Not fSuccess Or cbBytesRead = 0 Then
               Exit Do
            End If
        
            ShowLastStatus "Recieved : " + chRequest
            FlushFileBuffers ByVal PipeHandle
            DisconnectNamedPipe ByVal PipeHandle
        End If
    Loop
End Function

Private Sub btnStopServer_Click()
    FlushFileBuffers PipeHandle
    DisconnectNamedPipe PipeHandle
    CloseHandle PipeHandle
    ShowLastStatus "Server stopped successfully"
    PipeHandle = 0
End Sub

Private Sub Form_Load()
    PipeHandle = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    btnStopServer_Click
End Sub
